## python-gevent 1.2.2

=== Makefile ===
# This file is renamed to "Makefile.ext" in release tarballs so that setup.py won't try to
# run it.  If you want setup.py to run "make" automatically, rename it back to "Makefile".

# The pyvenv multiple runtime support is based on https://github.com/DRMacIver/hypothesis/blob/master/Makefile

PYTHON?=python${TRAVIS_PYTHON_VERSION}
CYTHON?=cython



export PATH:=$(BUILD_RUNTIMES)/snakepit:$(TOOLS):$(PATH)
export LC_ALL=C.UTF-8


all: src/gevent/libev/gevent.corecext.c src/gevent/gevent.ares.c src/gevent/gevent._semaphore.c

src/gevent/libev/gevent.corecext.c: src/gevent/libev/corecext.ppyx src/gevent/libev/libev.pxd util/cythonpp.py
	$(PYTHON) util/cythonpp.py -o gevent.corecext.c --module-name gevent.libev.corecext.pyx src/gevent/libev/corecext.ppyx
	echo '#include "callbacks.c"' >> gevent.corecext.c
	mv gevent.corecext.* src/gevent/libev/

src/gevent/gevent.ares.c: src/gevent/ares.pyx src/gevent/*.pxd
	$(CYTHON) -o gevent.ares.c src/gevent/ares.pyx
	mv gevent.ares.* src/gevent/

src/gevent/gevent._semaphore.c: src/gevent/_semaphore.py src/gevent/_semaphore.pxd
# On PyPy, if we wanted to use Cython to compile _semaphore.py, we'd
# need to have _semaphore named as a .pyx file so it doesn't get
# loaded in preference to the .so. (We want to keep the definitions
# separate in a .pxd file for ease of reading, and that only works
# with .py files, so we'd have to copy them back and forth.)
#	cp src/gevent/_semaphore.pyx src/gevent/_semaphore.py
	$(CYTHON) -o gevent._semaphore.c src/gevent/_semaphore.py
	mv gevent._semaphore.* src/gevent/
#	rm src/gevent/_semaphore.py

clean:
	rm -f corecext.pyx src/gevent/libev/corecext.pyx
	rm -f gevent.corecext.c gevent.corecext.h src/gevent/libev/gevent.corecext.c src/gevent/libev/gevent.corecext.h
	rm -f gevent.ares.c gevent.ares.h src/gevent/gevent.ares.c src/gevent/gevent.ares.h
	rm -f gevent._semaphore.c gevent._semaphore.h src/gevent/gevent._semaphore.c src/gevent/gevent._semaphore.h
	rm -f src/gevent/*.so src/gevent/libev/*.so
	rm -rf src/gevent/libev/*.o src/gevent/*.o
	rm -rf src/gevent/__pycache__ src/greentest/__pycache__ src/gevent/libev/__pycache__
	rm -rf src/gevent/*.pyc src/greentest/*.pyc src/gevent/libev/*.pyc
	rm -rf src/greentest/htmlcov src/greentest/.coverage
	rm -rf build

distclean: clean
	rm -rf dist
	rm -rf deps/libev/config.h deps/libev/config.log deps/libev/config.status deps/libev/.deps deps/libev/.libs
	rm -rf deps/c-ares/config.h deps/c-ares/config.log deps/c-ares/config.status deps/c-ares/.deps deps/c-ares/.libs

doc:
	cd doc && PYTHONPATH=.. make html

whitespace:
	! find . -not -path "*.pem" -not -path "./.eggs/*" -not -path "./src/greentest/htmlcov/*" -not -path "./src/greentest/.coverage.*" -not -path "./.tox/*" -not -path "*/__pycache__/*" -not -path "*.so" -not -path "*.pyc" -not -path "./.git/*" -not -path "./build/*"  -not -path "./src/gevent/libev/*" -not -path "./src/gevent.egg-info/*" -not -path "./dist/*" -not -path "./.DS_Store" -not -path "./deps/*" -not -path "./src/gevent/gevent.*.[ch]" -not -path "./src/gevent/corecext.pyx" -not -path "./doc/_build/*" -not -path "./doc/mytheme/static/*" -type f | xargs egrep -l " $$"

prospector:
	which prospector
	which pylint
# debugging
#	pylint --rcfile=.pylintrc --init-hook="import sys, code; sys.excepthook = lambda exc, exc_type, tb: print(tb.tb_next.tb_next.tb_next.tb_next.tb_next.tb_next.tb_next.tb_next.tb_next.tb_next.tb_frame.f_locals['self'])" gevent src/greentest/* || true
	${PYTHON} scripts/gprospector.py -X

lint: whitespace prospector

test_prelim:
	which ${PYTHON}
	${PYTHON} --version
	${PYTHON} -c 'import greenlet; print(greenlet, greenlet.__version__)'
	${PYTHON} -c 'import gevent.core; print(gevent.core.loop)'
	make bench

toxtest: test_prelim
	cd src/greentest && GEVENT_RESOLVER=thread ${PYTHON} testrunner.py --config known_failures.py --quiet

fulltoxtest: test_prelim
	cd src/greentest && GEVENT_RESOLVER=thread ${PYTHON} testrunner.py --config known_failures.py --quiet
	cd src/greentest && GEVENT_RESOLVER=ares GEVENTARES_SERVERS=8.8.8.8 ${PYTHON} testrunner.py --config known_failures.py --ignore tests_that_dont_use_resolver.txt --quiet
	cd src/greentest && GEVENT_FILE=thread ${PYTHON} testrunner.py --config known_failures.py `grep -l subprocess test_*.py` --quiet

leaktest:
	GEVENTSETUP_EV_VERIFY=3 GEVENTTEST_LEAKCHECK=1 make fulltoxtest

bench:
	${PYTHON} src/greentest/bench_sendall.py


travis_test_linters:
	make lint
	GEVENTTEST_COVERAGE=1 make leaktest
# because we set parallel=true, each run produces new and different coverage files; they all need
# to be combined
	coverage combine . src/greentest/

	coveralls --rcfile=src/greentest/.coveragerc


.PHONY: clean all doc prospector whitespace lint travistest travis

# Managing runtimes

BUILD_RUNTIMES?=$(PWD)/.runtimes

PY278=$(BUILD_RUNTIMES)/snakepit/python2.7.8
PY27=$(BUILD_RUNTIMES)/snakepit/python2.7.13
PY34=$(BUILD_RUNTIMES)/snakepit/python3.4.5
PY35=$(BUILD_RUNTIMES)/snakepit/python3.5.3
PY36=$(BUILD_RUNTIMES)/snakepit/python3.6.0
PYPY=$(BUILD_RUNTIMES)/snakepit/pypy571
PYPY3=$(BUILD_RUNTIMES)/snakepit/pypy3.5_571

TOOLS=$(BUILD_RUNTIMES)/tools

TOX=$(TOOLS)/tox

TOOL_VIRTUALENV=$(BUILD_RUNTIMES)/virtualenvs/tools
ISORT_VIRTUALENV=$(BUILD_RUNTIMES)/virtualenvs/isort
TOOL_PYTHON=$(TOOL_VIRTUALENV)/bin/python
TOOL_PIP=$(TOOL_VIRTUALENV)/bin/pip
TOOL_INSTALL=$(TOOL_PIP) install --upgrade

$(PY278):
	scripts/install.sh 2.7.8

$(PY27):
	scripts/install.sh 2.7

$(PY34):
	scripts/install.sh 3.4

$(PY35):
	scripts/install.sh 3.5

$(PY36):
	scripts/install.sh 3.6

$(PYPY):
	scripts/install.sh pypy

$(PYPY3):
	scripts/install.sh pypy3

PIP?=$(BUILD_RUNTIMES)/versions/$(PYTHON)/bin/pip

develop:
	ls -l $(BUILD_RUNTIMES)/snakepit/
	echo pip is at `which $(PIP)`
	echo python is at `which $(PYTHON)`
# First install a newer pip so that it can use the wheel cache
# (only needed until travis upgrades pip to 7.x; note that the 3.5
# environment uses pip 7.1 by default)
	${PIP} install -U pip
# Then start installing our deps so they can be cached. Note that use of --build-options / --global-options / --install-options
# disables the cache.
# We need wheel>=0.26 on Python 3.5. See previous revisions.
	${PIP} install -U -r dev-requirements.txt

lint-py27: $(PY27)
	PYTHON=python2.7.13 PATH=$(BUILD_RUNTIMES)/versions/python2.7.13/bin:$(PATH) make develop travis_test_linters

test-py27: $(PY27)
	PYTHON=python2.7.13 PATH=$(BUILD_RUNTIMES)/versions/python2.7.13/bin:$(PATH) make develop fulltoxtest

test-py278: $(PY278)
	ls $(BUILD_RUNTIMES)/versions/python2.7.8/bin/
	PYTHON=python2.7.8 PATH=$(BUILD_RUNTIMES)/versions/python2.7.8/bin:$(PATH) make develop toxtest

test-py34: $(PY34)
	PYTHON=python3.4.5 PIP=pip PATH=$(BUILD_RUNTIMES)/versions/python3.4.5/bin:$(PATH) make develop toxtest

test-py35: $(PY35)
	PYTHON=python3.5.3 PIP=pip PATH=$(BUILD_RUNTIMES)/versions/python3.5.3/bin:$(PATH) make develop fulltoxtest

test-py36: $(PY36)
	PYTHON=python3.6.0 PIP=pip PATH=$(BUILD_RUNTIMES)/versions/python3.6.0/bin:$(PATH) make develop toxtest

test-pypy: $(PYPY)
	PYTHON=$(PYPY) PIP=pip PATH=$(BUILD_RUNTIMES)/versions/pypy571/bin:$(PATH) make develop toxtest

test-pypy3: $(PYPY3)
	PYTHON=$(PYPY3) PIP=pip PATH=$(BUILD_RUNTIMES)/versions/pypy3.5_571/bin:$(PATH) make develop toxtest

test-py27-cffi: $(PY27)
	GEVENT_CORE_CFFI_ONLY=1 PYTHON=python2.7.13 PATH=$(BUILD_RUNTIMES)/versions/python2.7.13/bin:$(PATH) make develop toxtest

test-py27-noembed: $(PY27)
	cd deps/libev && ./configure --disable-dependency-tracking && make
	cd deps/c-ares && ./configure --disable-dependency-tracking && make
	CPPFLAGS="-Ideps/libev -Ideps/c-ares" LDFLAGS="-Ldeps/libev/.libs -Ldeps/c-ares/.libs" LD_LIBRARY_PATH="$(PWD)/deps/libev/.libs:$(PWD)/deps/c-ares/.libs" EMBED=0 GEVENT_CORE_CEXT_ONLY=1 PYTHON=python2.7.13 PATH=$(BUILD_RUNTIMES)/versions/python2.7.13/bin:$(PATH) make develop toxtest

=== debian/changelog ===
python-gevent (1.2.2-2) unstable; urgency=medium

  * Install libev submodule (closes: #876814).
  * Update packaging.

 -- Laszlo Boszormenyi (GCS) <gcs@debian.org>  Tue, 26 Sep 2017 15:38:16 +0000

python-gevent (1.2.2-1) unstable; urgency=low

  * New upstream release.
  * Add python-setuptools and cython Python variants to build depends.
  * Add cython-dbg to build depends to prevent FTBFS.
  * Add python3-sphinx build dependency.
  * Make package priority optional to match override.
  * Update Standards-Version to 4.1.0 .

 -- Laszlo Boszormenyi (GCS) <gcs@debian.org>  Sun, 24 Sep 2017 14:29:25 +0000

=== debian/control ===
Source: python-gevent
Priority: optional
Maintainer: Laszlo Boszormenyi (GCS) <gcs@debian.org>
Build-Depends: debhelper (>= 9), dh-python, autotools-dev, python-all-dev,
 libevent-dev (>= 1.4), python-greenlet | python-codespeak-lib (<< 1.0),
 python-sphinx (>= 1.0.7+dfsg), python-all-dbg,
 python-greenlet-dbg, python3-greenlet-dbg,
 python-setuptools, python3-setuptools,
 python3-all-dev, python3-all-dbg, python3-greenlet,
 python3-sphinx,
 cython, cython-dbg, cython3,
 libev-dev, libc-ares-dev
Standards-Version: 4.1.0
Section: python
Homepage: http://www.gevent.org/
X-Python-Version: >= 2.7
X-Python3-Version: >= 3.3

Package: python-gevent-dbg
Section: debug
Architecture: any
Depends: ${misc:Depends}, python-gevent (= ${binary:Version}), ${shlibs:Depends}, ${python:Depends},
 python-greenlet-dbg
Provides: ${python:Provides}
XB-Python-Version: ${python:Versions}
Description: gevent is a coroutine-based Python networking library - debugging symbols
 gevent uses greenlet to provide a high-level synchronous API on top of
 libevent event loop.
 .
 This is the debugging symbols for gevent.

Package: python-gevent-doc
Section: doc
Architecture: all
Multi-Arch: foreign
Depends: ${misc:Depends}, libjs-jquery, libjs-underscore
Description: gevent is a coroutine-based Python networking library - documentation
 gevent uses greenlet to provide a high-level synchronous API on top of
 libevent event loop.
 .
 This is the documentation for gevent.

Package: python-gevent
Section: python
Architecture: any
Depends: ${shlibs:Depends}, ${misc:Depends}, ${python:Depends}, python-greenlet (>= 0.3.2) | python-codespeak-lib (<< 1.0)
Provides: ${python:Provides}
XB-Python-Version: ${python:Versions}
Suggests: python-gevent-doc, python-gevent-dbg, python-openssl
Description: gevent is a coroutine-based Python networking library
 gevent uses greenlet to provide a high-level synchronous API on top of
 libevent event loop.

Package: python3-gevent
Section: python
Architecture: any
Depends: ${shlibs:Depends}, ${misc:Depends}, ${python3:Depends}, python3-greenlet
Provides: ${python3:Provides}
XB-Python-Version: ${python3:Versions}
Suggests: python-gevent-doc, python3-gevent-dbg, python3-openssl
Description: gevent is a coroutine-based Python networking library
 gevent uses greenlet to provide a high-level synchronous API on top of
 libevent event loop.

Package: python3-gevent-dbg
Section: debug
Architecture: any
Depends: ${misc:Depends}, python3-gevent (= ${binary:Version}), ${shlibs:Depends}, ${python3:Depends},
 python3-greenlet-dbg
Provides: ${python3:Provides}
XB-Python-Version: ${python3:Versions}
Description: gevent is a coroutine-based Python networking library - debugging symbols
 gevent uses greenlet to provide a high-level synchronous API on top of
 libevent event loop.
 .
 This is the debugging symbols for gevent.

=== debian/rules ===
#!/usr/bin/make -f
# -*- makefile -*-

# Uncomment this to turn on verbose mode.
#export DH_VERBOSE=1

export SHELL = /bin/bash

DOCDIR:=$(CURDIR)/debian/python-gevent-doc/usr/share/doc/python-gevent-doc

%:
	dh  $@ --parallel --with autotools_dev,python2,python3 --buildsystem=pybuild

override_dh_auto_build:
	dh_auto_build
	PYTHONPATH=../.pybuild/pythonX.Y_2.7/build/ make --directory doc/ html

override_dh_auto_clean:
	dh_auto_clean
	rm -f $(CURDIR)/gevent/*.so
	cd doc && make clean
	rm -f $(CURDIR)/doc/gevent.*.rst $(CURDIR)/doc/changelog.rst
	rm -rf $(CURDIR)/gevent.egg-info/
	rm -f $(CURDIR)/greentest/testresults.sqlite3
	[ ! -f libev/Makefile ] || (cd $(CURDIR)/libev/ && $(MAKE) distclean)
	rm -f $(CURDIR)/c-ares/ares_config.h $(CURDIR)/c-ares/config.log \
		$(CURDIR)/c-ares/config.status \
		$(CURDIR)/c-ares/stamp-h1 $(CURDIR)/c-ares/stamp-h2

override_dh_install:
	dh_install -O--parallel -O--buildsystem=pybuild --list-missing
	: # remove the compat stuff for 2/3
	rm -v -f debian/python-gevent/usr/lib/python2.7/dist-packages/gevent/_{util_py,ssl,fileobject,socket}3*
	rm -v -f debian/python3-gevent/usr/lib/python3*/dist-packages/gevent/_{util_py,ssl,fileobject,socket}2*

override_dh_compress:
	dh_compress -X.js -X_static/* -X _sources/* -X_sources/*/* -X.inv

override_dh_strip:
ifeq (,$(filter nostrip,$(DEB_BUILD_OPTIONS)))
	dh_strip -p python-gevent --dbg-package=python-gevent-dbg
	dh_strip -p python3-gevent --dbg-package=python3-gevent-dbg
endif

# TODO: check for failures, but disable for now
override_dh_auto_test:
#	chmod +x $(CURDIR)/src/greentest/testrunner.py
#	cd $(CURDIR)/src/greentest && PYTHONPATH=../.. ./testrunner.py

override_dh_installdocs-arch:
	dh_installdocs -Npython-gevent-dbg -Npython3-gevent-dbg
	dh_installdocs -ppython-gevent-dbg --link-doc=python-gevent
	dh_installdocs -ppython3-gevent-dbg --link-doc=python3-gevent

override_dh_installdocs-indep:
	dh_installdocs -i
	# remove privacy tracking links
	sed -i 's|http.*/btn_donateCC_LG.gif||' \
		$(DOCDIR)/html/sfc.html
	sed -i 's|http.*/pixel.gif||' \
		$(DOCDIR)/html/sfc.html
	sed -i 's|<a .\+twitter.com.\+>\(.\+\)</a>|\1|' \
		$(DOCDIR)/html/index.html
	sed -i 's|<script>.\+platform.twitter.com.\+</script>||' \
		$(DOCDIR)/html/index.html

override_dh_installexamples-indep:
	dh_installexamples -i
	# remove privacy tracking links
	sed -i 's|http.*/jquery.min.js|file://usr/share/javascript/jquery/jquery.min.js|' \
		debian/python-gevent-doc/usr/share/doc/python-gevent-doc/examples/webchat/templates/index.html


.PHONY: override_dh_auto_build override_dh_auto_clean override_dh_install \
	override_dh_compress override_dh_strip override_dh_auto_test \
	override_dh_installdocs-arch override_dh_installdocs-indep \
	override_dh_installexamples-indep

## python-gevent 1.3.5

=== debian/changelog ===
python-gevent (1.3.5-1) unstable; urgency=medium

  * New upstream release.
  * Fix Hurd PATH_MAX FTBFS.

 -- Laszlo Boszormenyi (GCS) <gcs@debian.org>  Sun, 22 Jul 2018 13:55:09 +0000

python-gevent (1.3.4-1) unstable; urgency=medium

  * New upstream release:
    - fixes Sphinx FTBFS (closes: #889140),
    - works with Python 3.7 (closes: #903145).
  * Remove outdated patches.
  * Remove outdated python{,3}-greenlet-dbg dependencies (closes: #901800).
  * Add python{,3}-cffi{,-backend-dbg} to build dependency for CFFI build.
  * Add python3-repoze.sphinx.autointerface to build dependency for
    documentation.
  * Install all files.
  * Update clean target.
  * Update privacy link removals.
  * Remove JavaScript symlinks, no longer needed.
  * Update debhelper level to 11:
    - remove autotools-dev build dependency,
    - don't specify parallel to debhelper,
    - update documentation directory,
    - use dh_missing for listing not installed files.
  * Update Standards-Version to 4.1.5 .

 -- Laszlo Boszormenyi (GCS) <gcs@debian.org>  Sat, 07 Jul 2018 17:23:32 +0000

=== debian/control ===
--- 
+++ 
@@ -1,26 +1,26 @@
 Source: python-gevent
 Priority: optional
 Maintainer: Laszlo Boszormenyi (GCS) <gcs@debian.org>
-Build-Depends: debhelper (>= 9), dh-python, autotools-dev, python-all-dev,
- libevent-dev (>= 1.4), python-greenlet | python-codespeak-lib (<< 1.0),
+Build-Depends: debhelper (>= 11), dh-python, python-all-dev,
+ libevent-dev (>= 1.4), python-greenlet (>= 0.4.13) | python-codespeak-lib (<< 1.0),
  python-sphinx (>= 1.0.7+dfsg), python-all-dbg,
- python-greenlet-dbg, python3-greenlet-dbg,
  python-setuptools, python3-setuptools,
- python3-all-dev, python3-all-dbg, python3-greenlet,
- python3-sphinx,
+ python-cffi,  python-cffi-backend-dbg,
+ python3-cffi, python3-cffi-backend-dbg,
+ python3-all-dev, python3-all-dbg, python3-greenlet (>= 0.4.13),
+ python3-sphinx, python3-repoze.sphinx.autointerface,
  cython, cython-dbg, cython3,
  libev-dev, libc-ares-dev
-Standards-Version: 4.1.0
+Standards-Version: 4.1.5
 Section: python
 Homepage: http://www.gevent.org/
 X-Python-Version: >= 2.7
-X-Python3-Version: >= 3.3
+X-Python3-Version: >= 3.4
 
 Package: python-gevent-dbg
 Section: debug
 Architecture: any
-Depends: ${misc:Depends}, python-gevent (= ${binary:Version}), ${shlibs:Depends}, ${python:Depends},
- python-greenlet-dbg
+Depends: ${misc:Depends}, python-gevent (= ${binary:Version}), ${shlibs:Depends}, ${python:Depends}
 Provides: ${python:Provides}
 XB-Python-Version: ${python:Versions}
 Description: gevent is a coroutine-based Python networking library - debugging symbols
@@ -33,7 +33,7 @@
 Section: doc
 Architecture: all
 Multi-Arch: foreign
-Depends: ${misc:Depends}, libjs-jquery, libjs-underscore
+Depends: ${misc:Depends}, libjs-jquery
 Description: gevent is a coroutine-based Python networking library - documentation
  gevent uses greenlet to provide a high-level synchronous API on top of
  libevent event loop.
@@ -65,8 +65,7 @@
 Package: python3-gevent-dbg
 Section: debug
 Architecture: any
-Depends: ${misc:Depends}, python3-gevent (= ${binary:Version}), ${shlibs:Depends}, ${python3:Depends},
- python3-greenlet-dbg
+Depends: ${misc:Depends}, python3-gevent (= ${binary:Version}), ${shlibs:Depends}, ${python3:Depends}
 Provides: ${python3:Provides}
 XB-Python-Version: ${python3:Versions}
 Description: gevent is a coroutine-based Python networking library - debugging symbols

## python-gevent 1.3.7

=== Makefile ===
# This file is renamed to "Makefile.ext" in release tarballs so that setup.py won't try to
# run it.  If you want setup.py to run "make" automatically, rename it back to "Makefile".

# The pyvenv multiple runtime support is based on https://github.com/DRMacIver/hypothesis/blob/master/Makefile

PYTHON?=python${TRAVIS_PYTHON_VERSION}
CYTHON?=cython



export PATH:=$(BUILD_RUNTIMES)/snakepit:$(TOOLS):$(PATH)
export LC_ALL=C.UTF-8
export GEVENT_RESOLVER_NAMESERVERS=8.8.8.8


clean:
	rm -f src/gevent/libev/corecext.c src/gevent/libev/corecext.h
	rm -f src/gevent/resolver/cares.c src/gevent/resolver/cares.h
	rm -f src/gevent/_semaphore.c src/gevent/_semaphore.h
	rm -f src/gevent/local.c src/gevent/local.h
	rm -f src/gevent/*.so src/gevent/*.pyd src/gevent/libev/*.so src/gevent/libuv/*.so src/gevent/libev/*.pyd src/gevent/libuv/*.pyd
	rm -rf src/gevent/libev/*.o src/gevent/libuv/*.o src/gevent/*.o
	rm -rf src/gevent/__pycache__ src/greentest/__pycache__ src/greentest/greentest/__pycache__ src/gevent/libev/__pycache__
	rm -rf src/gevent/*.pyc src/greentest/*.pyc src/gevent/libev/*.pyc
	rm -rf src/greentest/htmlcov src/greentest/.coverage
	rm -rf build

distclean: clean
	rm -rf dist
	rm -rf deps/libev/config.h deps/libev/config.log deps/libev/config.status deps/libev/.deps deps/libev/.libs
	rm -rf deps/c-ares/config.h deps/c-ares/config.log deps/c-ares/config.status deps/c-ares/.deps deps/c-ares/.libs

doc:
	cd doc && PYTHONPATH=.. make html

whitespace:
	! find . -not -path "*.pem" -not -path "./.eggs/*" -not -path "./src/greentest/htmlcov/*" -not -path "./src/greentest/.coverage.*" -not -path "./.tox/*" -not -path "*/__pycache__/*" -not -path "*.so" -not -path "*.pyc" -not -path "./.git/*" -not -path "./build/*"  -not -path "./src/gevent/libev/*" -not -path "./src/gevent.egg-info/*" -not -path "./dist/*" -not -path "./.DS_Store" -not -path "./deps/*" -not -path "./src/gevent/libev/corecext.*.[ch]" -not -path "./src/gevent/resolver/cares.*" -not -path "./doc/_build/*" -not -path "./doc/mytheme/static/*" -type f | xargs egrep -l " $$"

prospector:
	which pylint
	pylint --rcfile=.pylintrc gevent
# debugging
#	pylint --rcfile=.pylintrc --init-hook="import sys, code; sys.excepthook = lambda exc, exc_type, tb: print(tb.tb_next.tb_next.tb_next.tb_next.tb_next.tb_next.tb_next.tb_next.tb_next.tb_next.tb_frame.f_locals['self'])" gevent src/greentest/* || true
# XXX: prospector is failing right now. I can't reproduce locally:
# https://travis-ci.org/gevent/gevent/jobs/345474139
#	${PYTHON} scripts/gprospector.py -X

lint: prospector

test_prelim:
	@which ${PYTHON}
	@${PYTHON} --version
	@${PYTHON} -c 'import greenlet; print(greenlet, greenlet.__version__)'
	@${PYTHON} -c 'import gevent.core; print(gevent.core.loop)'
	@${PYTHON} -c 'import gevent.ares; print(gevent.ares)'
	@make bench

# Folding from https://github.com/travis-ci/travis-rubies/blob/9f7962a881c55d32da7c76baefc58b89e3941d91/build.sh#L38-L44

basictest: test_prelim
	@${PYTHON} scripts/travis.py fold_start basictest "Running basic tests"
	cd src/greentest && GEVENT_RESOLVER=thread ${PYTHON} testrunner.py --config known_failures.py --quiet
	@${PYTHON} scripts/travis.py fold_end basictest

alltest: basictest
	@${PYTHON} scripts/travis.py fold_start ares "Running c-ares tests"
	cd src/greentest && GEVENT_RESOLVER=ares ${PYTHON} testrunner.py --config known_failures.py --ignore tests_that_dont_use_resolver.txt --quiet
	@${PYTHON} scripts/travis.py fold_end ares
	@${PYTHON} scripts/travis.py fold_start dnspython "Running dnspython tests"
	cd src/greentest && GEVENT_RESOLVER=dnspython ${PYTHON} testrunner.py --config known_failures.py --ignore tests_that_dont_use_resolver.txt --quiet
	@${PYTHON} scripts/travis.py fold_end dnspython
# In the past, we included all test files that had a reference to 'subprocess'' somewhere in their
# text. The monkey-patched stdlib tests were specifically included here.
# However, we now always also test on AppVeyor (Windows) which only has GEVENT_FILE=thread,
# so we can save a lot of CI time by reducing the set and excluding the stdlib tests without
# losing any coverage. See the `threadfiletest` for what command used to run.
	@${PYTHON} scripts/travis.py fold_start thread "Running GEVENT_FILE=thread tests"
	cd src/greentest && GEVENT_FILE=thread ${PYTHON} testrunner.py --config known_failures.py test__*subprocess*.py --quiet
	@${PYTHON} scripts/travis.py fold_end thread

threadfiletest:
	cd src/greentest && GEVENT_FILE=thread ${PYTHON} testrunner.py --config known_failures.py `grep -l subprocess test_*.py` --quiet

allbackendtest:
	@${PYTHON} scripts/travis.py fold_start default "Testing default backend"
	GEVENTTEST_COVERAGE=1 make alltest
	@${PYTHON} scripts/travis.py fold_end default
	GEVENTTEST_COVERAGE=1 make cffibackendtest
# because we set parallel=true, each run produces new and different coverage files; they all need
# to be combined
	make coverage_combine


cffibackendtest:
	@${PYTHON} scripts/travis.py fold_start libuv "Testing libuv backend"
	GEVENT_LOOP=libuv make alltest
	@${PYTHON} scripts/travis.py fold_end libuv
	@${PYTHON} scripts/travis.py fold_start libev "Testing libev CFFI backend"
	GEVENT_LOOP=libev-cffi make alltest
	@${PYTHON} scripts/travis.py fold_end libev

leaktest: test_prelim
	@${PYTHON} scripts/travis.py fold_start leaktest "Running leak tests"
	cd src/greentest && GEVENT_RESOLVER=thread GEVENTTEST_LEAKCHECK=1 ${PYTHON} testrunner.py --config known_failures.py --quiet --ignore tests_that_dont_do_leakchecks.txt
	@${PYTHON} scripts/travis.py fold_end leaktest
	@${PYTHON} scripts/travis.py fold_start default "Testing default backend pure python"
	PURE_PYTHON=1 GEVENTTEST_COVERAGE=1 make basictest
	@${PYTHON} scripts/travis.py fold_end default

bench:
	${PYTHON} benchmarks/bench_sendall.py --loops 3 --processes 2 --values 2 --warmups 2 --quiet

travis_test_linters:
	make lint
	make leaktest
	make cffibackendtest

coverage_combine:
	coverage combine . src/greentest/
	-coveralls --rcfile=src/greentest/.coveragerc


.PHONY: clean doc prospector lint travistest travis

# Managing runtimes

BUILD_RUNTIMES?=$(PWD)/.runtimes

PY278=$(BUILD_RUNTIMES)/snakepit/python2.7.8
PY27=$(BUILD_RUNTIMES)/snakepit/python2.7.15
PY34=$(BUILD_RUNTIMES)/snakepit/python3.4.8
PY35=$(BUILD_RUNTIMES)/snakepit/python3.5.5
PY36=$(BUILD_RUNTIMES)/snakepit/python3.6.6
PY37=$(BUILD_RUNTIMES)/snakepit/python3.7.0
PYPY=$(BUILD_RUNTIMES)/snakepit/pypy600
PYPY3=$(BUILD_RUNTIMES)/snakepit/pypy3.5_600

TOOLS=$(BUILD_RUNTIMES)/tools

TOX=$(TOOLS)/tox

TOOL_VIRTUALENV=$(BUILD_RUNTIMES)/virtualenvs/tools
ISORT_VIRTUALENV=$(BUILD_RUNTIMES)/virtualenvs/isort
TOOL_PYTHON=$(TOOL_VIRTUALENV)/bin/python
TOOL_PIP=$(TOOL_VIRTUALENV)/bin/pip
TOOL_INSTALL=$(TOOL_PIP) install --upgrade


$(PY27):
	scripts/install.sh 2.7

$(PY34):
	scripts/install.sh 3.4

$(PY35):
	scripts/install.sh 3.5

$(PY36):
	scripts/install.sh 3.6

$(PY37):
	scripts/install.sh 3.7

$(PYPY):
	scripts/install.sh pypy

$(PYPY3):
	scripts/install.sh pypy3


develop:
	@${PYTHON} scripts/travis.py fold_start install "Installing gevent"
	@echo python is at `which $(PYTHON)`
# First install a newer pip so that it can use the wheel cache
# (only needed until travis upgrades pip to 7.x; note that the 3.5
# environment uses pip 7.1 by default)
	${PYTHON} -m pip install -U pip setuptools
# Then start installing our deps so they can be cached. Note that use of --build-options / --global-options / --install-options
# disables the cache.
# We need wheel>=0.26 on Python 3.5. See previous revisions.
	time ${PYTHON} -m pip install -U --upgrade-strategy=eager -r ci-requirements.txt
	GEVENTSETUP_EV_VERIFY=3 time ${PYTHON} -m pip install -U --upgrade-strategy=eager -e .[test,dnspython,events]
	${PYTHON} -m pip freeze
	ccache -s
	@${PYTHON} scripts/travis.py fold_end install

test-py27: $(PY27)
	PYTHON=python2.7.15 PATH=$(BUILD_RUNTIMES)/versions/python2.7.15/bin:$(PATH) make develop leaktest cffibackendtest coverage_combine

test-py34: $(PY34)
	PYTHON=python3.4.8 PATH=$(BUILD_RUNTIMES)/versions/python3.4.8/bin:$(PATH) make develop basictest

test-py35: $(PY35)
	PYTHON=python3.5.5 PATH=$(BUILD_RUNTIMES)/versions/python3.5.5/bin:$(PATH) make develop basictest

test-py36: $(PY36)
	PYTHON=python3.6.6 PATH=$(BUILD_RUNTIMES)/versions/python3.6.6/bin:$(PATH) make develop lint allbackendtest

test-py37: $(PY37)
	LD_LIBRARY_PATH=$(BUILD_RUNTIMES)/versions/python3.7.0/openssl/lib PYTHON=python3.7.0 PATH=$(BUILD_RUNTIMES)/versions/python3.7.0/bin:$(PATH) make develop leaktest cffibackendtest coverage_combine

test-pypy: $(PYPY)
	PYTHON=$(PYPY) PATH=$(BUILD_RUNTIMES)/versions/pypy600/bin:$(PATH) make develop cffibackendtest

test-pypy3: $(PYPY3)
	PYTHON=$(PYPY3) PATH=$(BUILD_RUNTIMES)/versions/pypy3.5_600/bin:$(PATH) make develop basictest

test-py27-noembed: $(PY27)
	@python2.7.15 scripts/travis.py fold_start conf_libev "Configuring libev"
	cd deps/libev && ./configure --disable-dependency-tracking && make
	@python2.7.15 scripts/travis.py fold_end conf_libev
	@python2.7.15 scripts/travis.py fold_start conf_cares "Configuring cares"
	cd deps/c-ares && ./configure --disable-dependency-tracking && make
	@python2.7.15 scripts/travis.py fold_end conf_cares
	@python2.7.15 scripts/travis.py fold_start conf_libuv "Configuring libuv"
	cd deps/libuv && ./autogen.sh && ./configure --disable-static && make
	@python2.7.15 scripts/travis.py fold_end conf_libuv
	CPPFLAGS="-Ideps/libev -Ideps/c-ares -Ideps/libuv/include" LDFLAGS="-Ldeps/libev/.libs -Ldeps/c-ares/.libs -Ldeps/libuv/.libs" LD_LIBRARY_PATH="$(PWD)/deps/libev/.libs:$(PWD)/deps/c-ares/.libs:$(PWD)/deps/libuv/.libs" EMBED=0 GEVENT_LOOP=libev-cext PYTHON=python2.7.15 PATH=$(BUILD_RUNTIMES)/versions/python2.7.15/bin:$(PATH) make develop basictest

=== debian/changelog ===
python-gevent (1.3.7-1) unstable; urgency=medium

  * New upstream release.

 -- Laszlo Boszormenyi (GCS) <gcs@debian.org>  Sat, 24 Nov 2018 15:48:01 +0000

python-gevent (1.3.6-1) unstable; urgency=medium

  * New upstream release.
  * Install all c-ares files for Python 3 (closes: #908144).
  * Put back python{,3}-greenlet-dbg dependencies for recent greenlet.
  * Update Standards-Version to 4.2.1 .

 -- Laszlo Boszormenyi (GCS) <gcs@debian.org>  Mon, 17 Sep 2018 22:08:48 +0000

=== debian/control ===
--- 
+++ 
@@ -2,25 +2,27 @@
 Priority: optional
 Maintainer: Laszlo Boszormenyi (GCS) <gcs@debian.org>
 Build-Depends: debhelper (>= 11), dh-python, python-all-dev,
- libevent-dev (>= 1.4), python-greenlet (>= 0.4.13) | python-codespeak-lib (<< 1.0),
+ libevent-dev (>= 1.4), python-greenlet (>= 0.4.15) | python-codespeak-lib (<< 1.0),
  python-sphinx (>= 1.0.7+dfsg), python-all-dbg,
+ python-greenlet-dbg, python3-greenlet-dbg,
  python-setuptools, python3-setuptools,
  python-cffi,  python-cffi-backend-dbg,
  python3-cffi, python3-cffi-backend-dbg,
- python3-all-dev, python3-all-dbg, python3-greenlet (>= 0.4.13),
+ python3-all-dev, python3-all-dbg, python3-greenlet (>= 0.4.15),
  python3-sphinx, python3-repoze.sphinx.autointerface,
  cython, cython-dbg, cython3,
  libev-dev, libc-ares-dev
-Standards-Version: 4.1.5
+Standards-Version: 4.2.1
 Section: python
 Homepage: http://www.gevent.org/
-X-Python-Version: >= 2.7
-X-Python3-Version: >= 3.4
+#X-Python-Version: >= 2.7
+#X-Python3-Version: >= 3.4
 
 Package: python-gevent-dbg
 Section: debug
 Architecture: any
-Depends: ${misc:Depends}, python-gevent (= ${binary:Version}), ${shlibs:Depends}, ${python:Depends}
+Depends: ${misc:Depends}, python-gevent (= ${binary:Version}), ${shlibs:Depends}, ${python:Depends},
+ python-greenlet-dbg
 Provides: ${python:Provides}
 XB-Python-Version: ${python:Versions}
 Description: gevent is a coroutine-based Python networking library - debugging symbols
@@ -65,7 +67,8 @@
 Package: python3-gevent-dbg
 Section: debug
 Architecture: any
-Depends: ${misc:Depends}, python3-gevent (= ${binary:Version}), ${shlibs:Depends}, ${python3:Depends}
+Depends: ${misc:Depends}, python3-gevent (= ${binary:Version}), ${shlibs:Depends}, ${python3:Depends},
+ python3-greenlet-dbg
 Provides: ${python3:Provides}
 XB-Python-Version: ${python3:Versions}
 Description: gevent is a coroutine-based Python networking library - debugging symbols

=== debian/rules ===
#!/usr/bin/make -f
# -*- makefile -*-

# Uncomment this to turn on verbose mode.
#export DH_VERBOSE=1

export SHELL = /bin/bash

DOCDIR:=$(CURDIR)/debian/python-gevent-doc/usr/share/doc/python-gevent

%:
	dh  $@ --with python2,python3 --buildsystem=pybuild

override_dh_auto_build:
	dh_auto_build
	PYTHONPATH=../src/ make --directory doc/ html

override_dh_auto_clean:
	dh_auto_clean
	make distclean
	make --directory doc/ clean
	rm -f $(CURDIR)/deps/c-ares/Makefile \
		$(CURDIR)/deps/c-ares/ares_build.h \
		$(CURDIR)/deps/c-ares/ares_config.h \
		$(CURDIR)/deps/c-ares/libcares.pc \
		$(CURDIR)/deps/c-ares/stamp-h1 \
		$(CURDIR)/deps/c-ares/stamp-h2
	rm -f $(CURDIR)/deps/libev/Makefile \
		$(CURDIR)/deps/libev/libtool \
		$(CURDIR)/deps/libev/stamp-h1
	rm -f $(CURDIR)/src/gevent/_greenlet_primitives.c \
	       	$(CURDIR)/src/gevent/_hub_local.c \
		$(CURDIR)/src/gevent/_hub_primitives.c \
		$(CURDIR)/src/gevent/_ident.c \
		$(CURDIR)/src/gevent/_imap.c \
		$(CURDIR)/src/gevent/_tracer.c \
		$(CURDIR)/src/gevent/_waiter.c \
		$(CURDIR)/src/gevent/event.c \
		$(CURDIR)/src/gevent/greenlet.c \
		$(CURDIR)/src/gevent/queue.c
	rm -rf $(CURDIR)/src/gevent.egg-info/

override_dh_install:
	dh_install -O--parallel -O--buildsystem=pybuild
	: # remove the compat stuff for 2/3
	rm -v -f debian/python-gevent/usr/lib/python2.7/dist-packages/gevent/_{util_py,ssl,fileobject,socket}3*
	rm -v -f debian/python3-gevent/usr/lib/python3*/dist-packages/gevent/_{util_py,ssl,fileobject,socket}2*

override_dh_compress:
	dh_compress -X.js -X_static/* -X _sources/* -X_sources/*/* -X.inv

override_dh_strip:
ifeq (,$(filter nostrip,$(DEB_BUILD_OPTIONS)))
	dh_strip -p python-gevent --dbg-package=python-gevent-dbg
	dh_strip -p python3-gevent --dbg-package=python3-gevent-dbg
endif

# TODO: check for failures, but disable for now
override_dh_auto_test:
#	chmod +x $(CURDIR)/src/greentest/testrunner.py
#	cd $(CURDIR)/src/greentest && PYTHONPATH=../.. ./testrunner.py

override_dh_installdocs-arch:
	dh_installdocs -Npython-gevent-dbg -Npython3-gevent-dbg
	dh_installdocs -ppython-gevent-dbg --link-doc=python-gevent
	dh_installdocs -ppython3-gevent-dbg --link-doc=python3-gevent

override_dh_installdocs-indep:
	dh_installdocs -i
	# remove privacy tracking links
	sed -i 's|https://www.paypal.com/.*.gif||' \
		$(DOCDIR)/html/sfc.html
	sed -i 's|"https://travis-ci.org/.*"|""|' \
		$(DOCDIR)/html/install.html
	sed -i 's|"https://coveralls.io/.*"|""|' \
		$(DOCDIR)/html/install.html
	sed -i 's|"https://ci.appveyor.com/.*"|""|' \
		$(DOCDIR)/html/install.html

override_dh_installexamples-indep:
	dh_installexamples -i
	# remove privacy tracking links
	sed -i 's|http.*/jquery.min.js|file://usr/share/javascript/jquery/jquery.min.js|' \
		$(DOCDIR)/examples/webchat/templates/index.html

override_dh_missing:
	dh_missing --list-missing -X.c -X.h -X.pxd -X.pyc -X.pyx

.PHONY: override_dh_auto_build override_dh_auto_clean override_dh_install \
	override_dh_compress override_dh_strip override_dh_auto_test \
	override_dh_installdocs-arch override_dh_installdocs-indep \
	override_dh_installexamples-indep override_dh_missing
